package org.kaoriha.jspbp.renderer.table;

import java.util.List;
import java.util.Map;

public class Data<ColT extends Enum<ColT>, CellT> {
	private final Query<ColT> query;
	private final CellT caption;
	private final List<Map<ColT, CellT>> cell;
	private final Map<ColT, CellT> header;
	private final Map<ColT, CellT> footer;
	private final List<ColT> columnList;
	private final int length;

	public Data(Query<ColT> query, CellT caption, List<Map<ColT, CellT>> cell,
			Map<ColT, CellT> header, Map<ColT, CellT> footer,
			List<ColT> columnList, int length) {
		this.query = query;
		this.caption = caption;
		this.cell = cell;
		this.header = header;
		this.footer = footer;
		this.columnList = columnList;
		this.length = length;
	}

	public Query<ColT> getQuery() {
		return query;
	}

	public CellT getCaption() {
		return caption;
	}

	public List<Map<ColT, CellT>> getCell() {
		return cell;
	}

	public Map<ColT, CellT> getHeader() {
		return header;
	}

	public Map<ColT, CellT> getFooter() {
		return footer;
	}

	public List<ColT> getColumnList() {
		return columnList;
	}

	public int getLength() {
		return length;
	}
}
